#!/bin/sh
# 
# do hourly ourmon summarization
#
# first run top N flows script
# then run top ip src, ip dst script
#
# variables overwritten at config time include
#	1. BASEDIR
#	2. OURNET
#
# everything else is relative to OURPATH

BASEDIR="/home/mrourmon"
OURPATH=$BASEDIR
#fix the probe to be consistent before introducing this feature
#OURNET="10.0.0.0/8"  

OURBIN=$OURPATH/bin
WEBDIR=$OURPATH/web.pages
BASELOGFILE="$OURPATH/logs/topn_today/topn_ip.log"
BASEICMPFILE="$OURPATH/logs/topn_today/topn_icmp.log"
BASEUDPFILE="$OURPATH/logs/topn_today/topn_udp.log"
BASESYNFILE="$OURPATH/logs/topn_today/syn_list.log"
BASEWORMDIR="$OURPATH/logs/tworm/tworm_today"
BASEP2PDIR="$OURPATH/logs/rawp2p/rawp2p_today"
BASESYNWFILE="$OURPATH/logs/topn_today/syn_worm.log"

OMBATCHIP=$OURBIN/ombatchip.pl 
OMBATCHIPSRC=$OURBIN/ombatchipsrc.pl 
OMBATCHSYN=$OURBIN/ombatchsyn.pl 

IRC=$OURBIN/irc.pl
TOPIPA=$OURBIN/topipa.pl
TCPWORM=$OURBIN/tcpworm.pl

# do top of top flow work
$OMBATCHIP other $BASELOGFILE $WEBDIR/topn_today.txt
$OMBATCHIP icmp $BASEICMPFILE $WEBDIR/topicmp_today.txt
$OMBATCHIP other $BASEUDPFILE $WEBDIR/topudp_today.txt

# do syn analysis
$OMBATCHSYN -N $BASESYNFILE $WEBDIR/topsyn_today.txt
$OMBATCHSYN -W 100 -N -c 1000 $BASESYNWFILE $WEBDIR/allworm_today.txt

# do top src/dst work
$OMBATCHIPSRC $BASELOGFILE $WEBDIR/topn_ipsrc_today.txt $WEBDIR/topn_ipdst_today.txt
$OMBATCHIPSRC $BASEICMPFILE $WEBDIR/topicmp_ipsrc_today.txt $WEBDIR/topicmp_ipdst_today.txt
$OMBATCHIPSRC $BASEUDPFILE $WEBDIR/topudp_ipsrc_today.txt $WEBDIR/topudp_ipdst_today.txt

# hourly irc summarization report
$IRC -d  $OURPATH/logs/rawirc/rawirc_today > $WEBDIR/ircreport_today.txt

# do combined log analysis (top "busy" ip addresses in multiple kinds of logs)
# release this later

#$TOPIPA -o $WEBDIR/topipa_today.html -wp http://ourmon.cat.pdx.edu/ourmon/topipa -report -do $WEBDIR/topipa -n 60 -s "1,2,2,2" -d /usr/home/mrourmon/logs/mon.lite/mon_today -dw /usr/home/mrourmon/logs/tworm/tworm_today 

# hourly tcpworm.pl summarization for tcpworm.txt files

# 4 kinds of hourly/daily summarization for tcpworm
# 1. all
# 2. 445 worms 
# 3. only weight 40 and above
# 4. p2p summarization only, not worm

# all unfiltered
$TCPWORM -i -z $BASEWORMDIR > $WEBDIR/wormsum.all_daily.txt

# port 445 only, weight 20 or above
$TCPWORM -i -w 20 -4 445 -z $BASEWORMDIR > $WEBDIR/wormsum.445_daily.txt

# all ports, weight 40 or above
$TCPWORM -i -w 40  -z $BASEWORMDIR > $WEBDIR/wormsum.40w_daily.txt

# p2p summarization
$TCPWORM -i -h -z $BASEP2PDIR > $WEBDIR/p2psum.daily.txt
